import net.nanex.NxCoreClass;
class CategorySample extends NxCoreClass{
    
    @Override
    public int OnNxCoreCallback(NxCoreSystem nxCoreSys, NxCoreMessage nxCoreMsg) {
        if (nxCoreMsg.MessageType ==  defines.NxMSG_CATEGORY) {
            NxCoreHeader header = nxCoreMsg.coreHeader;
            String symbol = header.pnxStringSymbol.String;
            NxTime timestamp = header.nxExgTimestamp;
            NxDate sessionDate = header.nxSessionDate;
            
            NxCoreCategory category = nxCoreMsg.coreData.Category;
            int categoryID = category.pnxStringCategory.Atom;
            NxCategoryField[] fields = category.pnxFields;
            
            if (categoryID == 4) {
                if (fields[0].Set == 1) {
                    String name = fields[0].data.StringZ;
                    System.out.println(symbol + " name is " + name);
                }
            }
            if (categoryID == 50 || categoryID == 52  || categoryID == 54){
                double high = 0.0;
                double low = 0.0;
                double last = 0.0;
                long volume = 0;
                if (fields[2].Set == 1)
                    high = PriceToDouble(fields[2].data.nxPrice.Price, fields[2].data.nxPrice.PriceType);
                if (fields[3].Set == 1)
                    low = PriceToDouble(fields[3].data.nxPrice.Price, fields[3].data.nxPrice.PriceType);
                if (fields[4].Set == 1)
                    last = PriceToDouble(fields[4].data.nxPrice.Price, fields[4].data.nxPrice.PriceType);
                if (fields[6].Set == 1)
                    volume = fields[6].data.i64Bit;
                System.out.println(
                    symbol + " on " + String.format("%d%02d%02d", sessionDate.Year, sessionDate.Month, sessionDate.Day)
                    + " had a high of $" +String.format("%.2f", high) + ", low of $"+ String.format("%.2f", low)
                    +", last of $" + String.format("%.2f", last) + ", and volume of " + volume + " shares");
            }
        }
        return defines.NxCALLBACKRETURN_CONTINUE;
    }
    
    public static void main(String args[]) {
        TradeSample nxCore = new TradeSample();
        
        if (args.length > 1 && nxCore.LoadNxCore(args[0]) != 0){
            int returnValue = nxCore.ProcessTape(args[1], 0, 0, 0);
            nxCore.ProcessReturnValue(returnValue);
        }
		else
			System.out.println("loading library failed");
    }
}