import net.nanex.NxCoreClass;
class DetailedQuoteSample extends NxCoreClass{
    
    @Override
    public int OnNxCoreCallback(NxCoreSystem nxCoreSys, NxCoreMessage nxCoreMsg) {
        if (nxCoreMsg.MessageType ==  defines.NxMSG_MMQUOTE) {
            NxCoreHeader header = nxCoreMsg.coreHeader;
            String symbol = header.pnxStringSymbol.String;
            NxTime timestamp = header.nxExgTimestamp;
            
			NxCoreMMQuote quote = nxCoreMsg.coreData.MMQuote;
            NxCoreQuote coreQuote = quote.coreQuote;
            String marketMaker =  quote.pnxStringMarketMaker.String;
            int sizeBid = coreQuote.BidSize;
            int sizeAsk = coreQuote.AskSize;
            double priceBid = PriceToDouble(coreQuote.BidPrice, coreQuote.PriceType);
            double priceAsk = PriceToDouble(coreQuote.AskPrice, coreQuote.PriceType);
            
            System.out.println("Market Maker Quote for " + symbol + " at "
                + String.format("%02d:%02d:%02d", timestamp.Hour, timestamp.Minute, timestamp.Second)
                + " by: " + marketMaker + " Bid: " + sizeBid + " lots at $" + String.format("%.2f", priceBid)
                + " Ask: " + sizeAsk + " lots at $" + String.format("%.2f", priceAsk));
        }
        if (nxCoreMsg.MessageType ==  defines.NxMSG_EXGQUOTE) {
            NxCoreHeader header = nxCoreMsg.coreHeader;
            String symbol = header.pnxStringSymbol.String;
            NxTime timestamp = header.nxExgTimestamp;
            
            NxCoreExgQuote quote = nxCoreMsg.coreData.ExgQuote;
            if (quote.BBOChangeFlags == 0)
                return defines.NxCALLBACKRETURN_CONTINUE;
            int sizeBid = quote.BestBidSize;
            int sizeAsk = quote.BestAskSize;
            double priceBid = PriceToDouble(quote.BestBidPrice, quote.coreQuote.PriceType);
            double priceAsk = PriceToDouble(quote.BestAskPrice, quote.coreQuote.PriceType);
            
            System.out.println("New NBBO Quote for " + symbol + " at "
                + String.format("%02d:%02d:%02d", timestamp.Hour, timestamp.Minute, timestamp.Second)
                + " Bid: " + sizeBid + " lots at $" + String.format("%.2f", priceBid)
                + " Ask: " + sizeAsk + " lots at $" + String.format("%.2f", priceAsk));
        }
        return defines.NxCALLBACKRETURN_CONTINUE;
    }
    
    public static void main(String args[]) {
        TradeSample nxCore = new TradeSample();
        
        if (args.length > 1 && nxCore.LoadNxCore(args[0]) != 0){
            int returnValue = nxCore.ProcessTape(args[1], 0, 0, 0);
            nxCore.ProcessReturnValue(returnValue);
        }
		else
			System.out.println("loading library failed");
    }
}