import net.nanex.NxCoreClass;
class QuoteSample extends NxCoreClass{
    
    @Override
    public int OnNxCoreCallback(NxCoreSystem nxCoreSys, NxCoreMessage nxCoreMsg) {
        if (nxCoreMsg.MessageType ==  defines.NxMSG_EXGQUOTE) {
            NxCoreHeader header = nxCoreMsg.coreHeader;
            String symbol = header.pnxStringSymbol.String;
            NxTime timestamp = header.nxExgTimestamp;
            String exchange = GetDefinedString(defines.NxST_EXCHANGE, header.ReportingExg);
            
            NxCoreQuote coreQuote = nxCoreMsg.coreData.ExgQuote.coreQuote;
            int sizeBid = coreQuote.BidSize;
            int sizeAsk = coreQuote.AskSize;
            double priceBid = PriceToDouble(coreQuote.BidPrice, coreQuote.PriceType);
            double priceAsk = PriceToDouble(coreQuote.AskPrice, coreQuote.PriceType);
            
            System.out.println("Quote for " + symbol + " on Exchange " + exchange + " at "
                + String.format("%02d:%02d:%02d", timestamp.Hour, timestamp.Minute, timestamp.Second)
                + " Bid: " + sizeBid + " lots at $" + String.format("%.2f", priceBid)
                + " Ask: " + sizeAsk + " lots at $" + String.format("%.2f", priceAsk));
        }
        return defines.NxCALLBACKRETURN_CONTINUE;
    }
    
    public static void main(String args[]) {
        TradeSample nxCore = new TradeSample();
        
        if (args.length > 1 && nxCore.LoadNxCore(args[0]) != 0){
            int returnValue = nxCore.ProcessTape(args[1], 0, 0, 0);
            nxCore.ProcessReturnValue(returnValue);
        }
		else
			System.out.println("loading library failed");
    }
}