import net.nanex.NxCoreClass;
class StatusSample extends NxCoreClass{
    
    @Override
    public int OnNxCoreCallback(NxCoreSystem nxCoreSys, NxCoreMessage nxCoreMsg) {
        if (nxCoreMsg.MessageType ==  defines.NxMSG_STATUS) {
            if (nxCoreSys.ClockUpdateInterval >= defines.NxCLOCK_MINUTE) {
                int year = nxCoreSys.nxDate.Year;
                int month = nxCoreSys.nxDate.Month;
                int day = nxCoreSys.nxDate.Day;
                int hour = nxCoreSys.nxTime.Hour;
                int minute = nxCoreSys.nxTime.Minute;
                System.out.println(String.format("%02d/%02d/%04d %02d:%02d", month, day, year, hour, minute));
            }
            
            if (nxCoreSys.Status  == defines.NxCORESTATUS_WAITFORCOREACCESS)
                System.out.println("Waiting on NxCore Access");
            
            if (nxCoreSys.Status  == defines.NxCORESTATUS_ERROR)
                System.out.println("tape error:" + nxCoreSys.StatusData);
            
            if (nxCoreSys.Status  == defines.NxCORESTATUS_INITIALIZING) {
                int major = GetMajorVersion(nxCoreSys.DLLVersion);
                int minor = GetMinorVersion(nxCoreSys.DLLVersion);
                int build = GetBuildVersion(nxCoreSys.DLLVersion);
                System.out.println("Initialized with decoder version "+String.format("%d.%d.%d",major,minor,build));
            }
        }
        return defines.NxCALLBACKRETURN_CONTINUE;
    }
    
    public static void main(String args[]) {
        TradeSample nxCore = new TradeSample();
        
        if (args.length > 1 && nxCore.LoadNxCore(args[0]) != 0){
            int returnValue = nxCore.ProcessTape(args[1], 0, 0, 0);
            nxCore.ProcessReturnValue(returnValue);
        }
		else
			System.out.println("loading library failed");
    }
}