import net.nanex.NxCoreClass;
class SymbolSample extends NxCoreClass{
    
    @Override
    public int OnNxCoreCallback(NxCoreSystem nxCoreSys, NxCoreMessage nxCoreMsg) {
        if (nxCoreMsg.MessageType == defines.NxMSG_SYMBOLSPIN) {
            NxCoreHeader header = nxCoreMsg.coreHeader;
            String symbol = header.pnxStringSymbol.String;
            String exchange = GetDefinedString(defines.NxST_EXCHANGE, header.ListedExg);
			
			System.out.println("symbol " + symbol + " is listed on " + exchange);
		}
		if (nxCoreMsg.MessageType == defines.NxMSG_SYMBOLCHANGE && nxCoreMsg.coreData.SymbolChange.Status == defines.NxSS_ADD) {
            NxCoreHeader header = nxCoreMsg.coreHeader;
            String symbol = header.pnxStringSymbol.String;
            String exchange = GetDefinedString(defines.NxST_EXCHANGE, header.ListedExg);
			
			System.out.println("new symbol " + symbol + " is listed on " + exchange);
		}
        return defines.NxCALLBACKRETURN_CONTINUE;
    }
    
    public static void main(String args[]) {
        TradeSample nxCore = new TradeSample();
        
        if (args.length > 1 && nxCore.LoadNxCore(args[0]) != 0){
            int returnValue = nxCore.ProcessTape(args[1], 0, 0, 0);
            nxCore.ProcessReturnValue(returnValue);
        }
		else
			System.out.println("loading library failed");
    }
}