import net.nanex.NxCoreClass;
class TradeSample extends NxCoreClass{
	
    @Override
    public int OnNxCoreCallback(NxCoreSystem nxCoreSys, NxCoreMessage nxCoreMsg) {
        if (nxCoreMsg.MessageType ==  defines.NxMSG_TRADE) {
            NxCoreHeader header = nxCoreMsg.coreHeader;
            String symbol = header.pnxStringSymbol.String;
            NxTime timestamp = header.nxExgTimestamp;
            
            NxCoreTrade trade = nxCoreMsg.coreData.Trade;
            double price = PriceToDouble(trade.Price,trade.PriceType);
            int size = trade.Size;
            
            System.out.println("Trade for " + symbol + " at "
                + String.format("%02d:%02d:%02d", timestamp.Hour, timestamp.Minute, timestamp.Second)
                + " for " + size + " shares at $" + String.format("%.2f", price));
        }
        return defines.NxCALLBACKRETURN_CONTINUE;
    }
    
    public static void main(String args[]) {
        TradeSample nxCore = new TradeSample();
        
        if (args.length > 1 && nxCore.LoadNxCore(args[0]) != 0){
            int returnValue = nxCore.ProcessTape(args[1], 0, 0, 0);
            nxCore.ProcessReturnValue(returnValue);
        }
		else
			System.out.println("loading library failed");
    }
}